import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkMoneyLog, ThinkMoneyLogParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkMoneyLog(params: ThinkMoneyLogParam) {
  const res = await request.get<ApiResult<PageResult<ThinkMoneyLog>>>(
    THINK_API_URL + '/think/think-money-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkMoneyLog(params?: ThinkMoneyLogParam) {
  const res = await request.get<ApiResult<ThinkMoneyLog[]>>(
    THINK_API_URL + '/think/think-money-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkMoneyLog(data: ThinkMoneyLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-money-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkMoneyLog(data: ThinkMoneyLog) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-money-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkMoneyLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-money-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkMoneyLog(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-money-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkMoneyLog(id: number) {
  const res = await request.get<ApiResult<ThinkMoneyLog>>(
    THINK_API_URL + '/think/think-money-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
